//+------------------------------------------------------------------+
//|                                   Bollinger bands experiment.mq4 |
//|                                                           mladen |
//+------------------------------------------------------------------+
#property copyright "copyleft mladen"
#property link      "mladenfx@gmail.com"

#property indicator_chart_window
#property indicator_buffers 5
#property indicator_color1 DimGray
#property indicator_color2 Lime
#property indicator_color3 Red
#property indicator_color4 Green
#property indicator_color5 Red
#property indicator_style1 STYLE_DOT
#property indicator_style4 STYLE_DOT
#property indicator_style5 STYLE_DOT

//
//
//
//
//

extern int    BandsLength        = 20;
extern double BandsDeviation     = 2.0;
extern bool   ShowBollingerBands = true;

//
//
//
//
//

double MaBuffer[];
double UpperBand1[];
double LowerBand1[];
double UpperBand2[];
double LowerBand2[];
double prices[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

int init()
{
   IndicatorBuffers(6);
   SetIndexBuffer(0,MaBuffer);
   SetIndexBuffer(1,UpperBand1);
   SetIndexBuffer(2,LowerBand1);
   SetIndexBuffer(3,UpperBand2);
   SetIndexBuffer(4,LowerBand2);
   SetIndexBuffer(5,prices);

   //
   //
   //
   //
   //

   SetIndexLabel(0,"Bands ma");
   SetIndexLabel(1,"Bands upper band 1");
   SetIndexLabel(2,"Bands lower band 1");
   SetIndexLabel(3,"Bands upper band 2");
   SetIndexLabel(4,"Bands lower band 2");
   return(0);
}
int deinit()
{
   return(0);
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

int start()
{
   double sum,ma;
   int    counted_bars=IndicatorCounted();
   int    limit,i,k;


   if(counted_bars < 0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = Bars-counted_bars;
         
   //
   //
   //
   //
   //

   for (i=limit;i>=0;i--)
      {
         prices[i] = iMA(NULL,0,1,0,MODE_SMA,PRICE_CLOSE,i);
         ma        = iMA(NULL,0,BandsLength,0,MODE_SMA,PRICE_CLOSE,i);
               for (sum = 0.0, k = 0; k < BandsLength; k++)
                    sum += ((prices[k+i]-ma)*(prices[k+i]-ma));

         //
         //
         //
         //
         //
         
         double deviation = MathSqrt(sum/BandsLength);
         double r2raw     = iCorrelation(prices,BandsLength,i);
         
         MaBuffer[i]   = ma;
         UpperBand1[i] = ma+(BandsDeviation*r2raw)*deviation;
         LowerBand1[i] = ma-(BandsDeviation*r2raw)*deviation;
         if (ShowBollingerBands)
         {            
            UpperBand2[i] = ma+BandsDeviation*deviation;
            LowerBand2[i] = ma-BandsDeviation*deviation;
         }            
      }            
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

double iCorrelation(double& array[],int period,int i)
{
   int matches = 0;
   for (int k=0; k<period; k++)
   {
      if (array[i+k] <= array[i+k+1]) continue;
      matches++;
   }
   return (2.0*matches/period-1);
}